(*-----------------------------------------------------------------------*)
(* Unit KEPLIB: functions and subroutines for keplerian orbits           *)
(*-----------------------------------------------------------------------*)

{$N+,E+}       {Coprozessor verwenden, wenn nicht da emulieren !}
{$G-}          {Code erzeugen fuer 8086 CPU}

UNIT KEPLIB;

INTERFACE

  USES MATLIB, SPHLIB;

  FUNCTION  ECCANOM  ( MAN,ECC: extended ): extended;
  PROCEDURE ELEMENT  ( JDA,JDB: extended; RA,RB: VECTOR;
                       VAR TP,Q,ECC,INC,LAN,AOP: extended );
  PROCEDURE ELLIP    ( M,A,ECC: extended; VAR X,Y,VX,VY: extended );
  FUNCTION  FIND_ETA ( RA,RB: VECTOR; TAU: extended ): extended;
  FUNCTION  HYPANOM  ( MH,ECC: extended ): extended;
  PROCEDURE HYPERB   ( T0,T,A,ECC: extended; VAR X,Y,VX,VY: extended );
  PROCEDURE KEPLER   ( T0,T,Q,ECC: extended; PQR: extended33;
                       VAR X,Y,Z,VX,VY,VZ: extended );
  PROCEDURE PARAB    ( T0,T,Q,ECC: extended; VAR X,Y,VX,VY: extended );
  PROCEDURE STUMPFF  ( E2: extended; VAR C1,C2,C3: extended );

IMPLEMENTATION

  (*$I \KEPLER\KEPLER.PAS *)

END.
