
{PROGRAMM:  Nautisches Jahrbuch                      }
{           Zur Berechnung der einzelnen Tagesseiten }

{$N+,E+}       {Coprozessor verwenden, wenn nicht da emulieren !}
{$G-}          {Code erzeugen fuer 8086 CPU}
{$I-}          {Bei fehlern kein Runtime error }

PROGRAM NJ(INPUT,OUTPUT);

  uses printer,matlib, pnulib, sphlib, moolib, sunlib, p15lib,
       p69lib, timlib, crt, dos;

  CONST T_OVERLAP  = 3.42E-6;        (* 3h  in Julian centuries *)
        T_DEVELOP  = 2.737850787E-4; (* 10d in Julian centuries *)

  VAR RA,DE,R,PAR, MODJD,HOUR : extended;
      T,DT,T_START,T_END,TA,TB: extended;
      DAY,MONTH,YEAR,NLINE    : INTEGER;
      RA_POLY,DE_POLY,R_POLY  : TPOLYNOM;
                    ch, ch2   : char;
      datum, dat, datu,
      wahl, ausgabemedium, aktion    : STRING;
      ende, dateischreiben,esc       : BOOLEAN;
      datei                          : TEXT;
      grt, dec, ariesgrad,  stu, min, sek, jd, zaehl, unt       : extended;
      dealt, paralt, grtalt, ariesalt,  untgrt, gg, tko   : extended;
      hpplanet,grtplan, decplan, grtplanalt,decplanalt, untsonne : extended;
      tag, monat, jahr, anzahl, tageszahl    : INTEGER;

      Transitus   : extended;

      name          : ARRAY[1..80] OF STRING;
      winkel, decli : ARRAY[1..80] OF EXTENDED;



PROCEDURE eingabe (VAR ergebnis : string);
VAR lang : INTEGER;
    hier : BOOLEAN;

BEGIN
  ergebnis := '';
  REPEAT
    hier := false;
    ch := readkey;
    if ord(ch) > 31 THEN write (ch);
    if ord (ch) = 8 THEN BEGIN
                            hier := True;
                            GOTOXY (WHEREX-1, WHEREY); WRITE (' ');
                            gotoxy (WHEREX-1, WHEREY);
                            lang := LENGTH (ergebnis);
                            ergebnis := COPY (ergebnis,1,lang-1);
                          END;
    if ord(ch) > 31 THEN ergebnis := ergebnis + ch ;
  UNTIL (ch = chr(27)) OR (ch = chr(13));
  if ch = chr(27) THEN BEGIN
                         ESC := TRUE;
                         EXIT; EXIT;
                       END;
  WRITELN;
END;


function RAnachGRT (raa:extended):extended;
BEGIN
  raa:=raa*360/24;
  raa:=ariesgrad-raa;
  IF raa<0 THEN raa:=raa+360;
  RAnachGRT := raa;
END;



PROCEDURE PLANETI (DAY, MONTH, YEAR :INTEGER; stu, min, sec:extended;
                   planet :STRING);

VAR   TEQX, ent                            : extended;
      X,Y,Z, XP,YP,ZP, XS,YS,ZS            : extended;
      L,B,R, LS,BS,RS, DELTA,DELTA0        : extended;
      A                                    : extended;
      iplan                                : INTEGER;

BEGIN (* PLANPOS *)
        L:=0;  B:=0;  R:=0;
    {    hour := stu+(min/60)+(sec/3600);
        MODJD := MJD (DAY,MONTH,YEAR,HOUR);
        T:=(MODJD-51544.5)/36525.0;
     }
        SUN200(T,LS,BS,RS);

        IF planet = 'Sonne'   THEN iplan := 0;
        IF planet = 'Venus'   THEN iplan := 2;
        IF planet = 'Mars'    THEN iplan := 4;
        IF planet = 'Jupiter' THEN iplan := 5;
        IF planet = 'Saturn'  THEN iplan := 6;


         IF IPLAN >2 THEN  BEGIN L:=LS+180.0; B:=-BS; R:=RS; END;

            CASE IPLAN OF
              2: VEN200(T,L,B,R);
              4: MAR200(T,L,B,R); 5: JUP200(T,L,B,R); 6: SAT200(T,L,B,R);
             END;



            (* geocentric ecliptic coordinates (light-time corrected)  *)

            GEOCEN (T, L,B,R, LS,BS,RS, IPLAN,2,
                    XP,YP,ZP, XS,YS,ZS, X,Y,Z,DELTA0);

            (* precession, equatorial coordinates, nutation            *)


                ECLEQU(T,X,Y,Z); NUTEQU(T,X,Y,Z);

            (* spherical coordinates *)

            POLAR (XP,YP,ZP,R,B,L);
            POLAR (X,Y,Z,DELTA,DEC,RA); RA:=RA/15.0;

            (* output *)


            ENT := DELTA0 * 149.59787E6;
            HPplanet := ASN (6378.14/ENT);

            grtplan := RAnachGRT (RA);
            decplan := DEC;

END;





PROCEDURE ARIESPFLEGER (t1,m1,j1,h1,m9,s9 : INTEGER);
  VAR  T : EXTENDED;
BEGIN
  T := MJD (t1 ,m1,j1, h1 + m9/60 + s9/3600);
  ariesgrad := 15 * LMST (T,0);
END;





PROCEDURE drucknj (plang, pland, L,untgrt,B,unt,P, A:extended);
  VAR H,M: INTEGER;
      S  : extended;
  BEGIN
    DMS (plang,h,m,s);
    WRITE (lst,'  ',H:3,(M+S/60):5:1,'');
    IF pland < 0 THEN BEGIN
                        WRITE (lst,'S');
                        pland := ABS (pland);
                      END
                      ELSE WRITE (lst,'N');
    DMS (pland,h,m,s);
    WRITE (lst,H:3,(M+S/60):5:1);

    DMS(L,H,M,S);
    WRITE (lst,'',H:4,(M+S/60):5:1,' ',untgrt:5:1,'');

    DMS(B,H,M,S);
    IF b < 0 THEN BEGIN
                    WRITE (lst,'S');
                    b := ABS (b);
                  END
                  ELSE  WRITE (lst,'N');
    DMS (B,H,M,S);
    WRITE (lst,H:3,(M+S/60):5:1,' ',unt:5:1);

    DMS(P,H,M,S);
    IF (H>0) THEN M:=M+60;  WRITE (lst,'',(M+S/60):5:1);

    DMS (A,H,M,S);
    WRITELN (lst,' ',H:4,(M+S/60):5:1);
  END;





PROCEDURE plandruck;

VAR  H, M  : INTEGER;
     S, T1, T2, DT, hpvenus, hpmars, hpjupiter, hpsaturn           : extended;
     decplanv, decplanvalt, summev, summem, summej, summes, dif    : extended;
     decplanm, decplanj, decplans, decplanmalt, decplanjalt,
     decplansalt, unt, untv,grtplanv, grtplanvalt, grtplanm,
     grtplanmalt, grtplanj, grtplanjalt, grtplans, grtplansalt,
     untj, unts, untm                                              : extended;

BEGIN
  hour := 0;  summev :=0;  summem :=0; summej :=0;  summes :=0;
  untv := 0;  untm := 0;  untj := 0;  unts := 0; unt :=0;

  T := T_START;
  MODJD := T * 36525.0 + 51544.5;  CALDAT (MODJD+(0.5/12),day,month,year,hour);

  T1 :=  ( MJD(day,month,year,hour) - 51544.5 ) / 36525.0;
  T2 :=  ( MJD(day,month,year,hour+23.1) - 51544.5 ) / 36525.0;
  DT := (1/24)/36525;
  T := T1;

  IF AUSGABEMEDIUM = 'HP'THEN
  BEGIN
    WRITELN (lst);
    WRITELN
    (Lst,'                                 ',chr(27),'&d1D',
    ' VENUS ',chr(27),'&d@',
    '            ',chr(27),'&d1D',' MARS ',chr(27),'&d@',
    '          ',chr(27),'&d1D',' JUPITER ',chr(27),'&d@',
    '          ',chr(27),'&d1D',' SATURN ',chr(27),'&d@','     ');
  END;


  IF AUSGABEMEDIUM = 'EPSON' THEN
  BEGIN
    WRITELN (lst);
    WRITELN
    (Lst,'        ',chr(27),'-1',' VENUS ',chr(27),'-0',
    '            ',chr(27),'-1',' MARS ',chr(27),'-0',
    '          ',chr(27),'-1',' JUPITER ',chr(27),'-0',
    '          ',chr(27),'-1',' SATURN ',chr(27),'-0','     ');
  END;

   IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
  WRITELN
  (lst,'UT1  Grt              Grt              Grt              Grt            ');
   IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
  WRITELN
  (lst,' h                                                 ');

  NLINE := 0;
  WHILE T < T2 DO
  BEGIN
    MODJD := T * 36525.0 + 51544.5;   CALDAT (MODJD, DAY, MONTH, YEAR, hour);
    ARIESPFLEGER (day, month, year, ROUND(hour), 0,0);

    IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
    WRITE (lst,ABS(hour):2:0,' ');

    grtplanvalt := grtplanv;
    decplanvalt := decplanv;
    planeti (day, month, year, hour, 0,0, 'Venus');
    DMS (grtplan,H,M,S);
    WRITE (lst,H:3,(m+s/60):5:1,'');
    decplanv := decplan;
    grtplanv := grtplan;
    IF decplanv < 0 THEN WRITE (lst,'S')  ELSE WRITE (lst,'N');
    decplanv := ABS (decplanv);
    DMS (decplanv,H,M,S);
    IF (hour > 0) AND (hour < 23) THEN
    BEGIN
      dif := ABS (decplanv-decplanvalt);
      summev :=summev + dif;
      IF grtplanv < grtplanvalt THEN grtplanv := grtplanv +360;
      unt := grtplanv - grtplanvalt - 15;
      untv := untv + unt;
    END;
    WRITE (lst,H:3,(m+s/60):5:1,'');
    IF INT(hour) = 12 THEN hpvenus:=hpplanet*60;

    grtplanmalt := grtplanm;
    decplanmalt := decplanm;
    planeti (day, month, year, hour, 0,0, 'Mars');
    DMS (grtplan,H,M,S);
    WRITE (lst,H:3,(m+s/60):5:1,'');
    decplanm := decplan;
    grtplanm := grtplan;
    IF decplan < 0 THEN WRITE (lst,'S')  ELSE WRITE (lst,'N');
    decplan :=  ABS (decplan);
    DMS (decplan,H,M,S);
    IF (hour > 0) AND (hour < 23) THEN
    BEGIN
      dif := ABS (decplanm-decplanmalt);
      summem :=summem + dif;
      IF grtplanm < grtplanmalt THEN grtplanm := grtplanm + 360;
      unt := grtplanm - grtplanmalt - 15;
      untm := untm + unt;
    END;
    WRITE (lst,H:3,(m+s/60):5:1,'');
    IF INT(hour) = 12 THEN hpmars := hpplanet*60;

    grtplanjalt := grtplanj;
    decplanjalt := decplanj;
    planeti (day, month, year, hour, 0,0, 'Jupiter');
    DMS (grtplan,H,M,S);
    WRITE (lst,H:3,(m+s/60):5:1,'');
    decplanj := decplan;
    grtplanj := grtplan;
    IF decplan < 0 THEN WRITE (lst,'S')  ELSE WRITE (lst,'N');
    decplan := ABS (decplan);
    DMS (decplan,H,M,S);
    IF (hour > 0) AND (hour < 23) THEN
    BEGIN
      dif := ABS (decplanj-decplanjalt);
      summej :=summej + dif;
      IF grtplanj < grtplanjalt THEN grtplanj := grtplanj + 360;
      unt := grtplanj- grtplanjalt - 15;
      untj := untj + unt;
    END;
    WRITE (lst,H:3,(m+s/60):5:1,'');
    IF INT(hour) = 12 THEN hpjupiter := hpplanet*60;

    grtplansalt := grtplans;
    decplansalt := decplans;
    planeti (day, month, year, hour, 0,0, 'Saturn');
    DMS (grtplan,H,M,S);
    WRITE (lst,H:3,(m+s/60):5:1,'');
    decplans := decplan;
    grtplans := grtplan;
    IF decplan < 0 THEN WRITE (lst,'S')  ELSE WRITE (lst,'N');
    decplan := ABS (decplan);
    DMS (decplan,H,M,S);
    IF (hour > 0) AND (hour < 23) THEN
    BEGIN
      dif := ABS (decplans-decplansalt);
      summes :=summes + dif;
      IF grtplans < grtplansalt THEN grtplans := grtplans + 360;
      unt := grtplans - grtplansalt -15;
      unts := unts + unt;
    END;
    WRITELN (lst,H:3,(m+s/60):5:1,'');
    IF INT(hour) = 12 THEN hpsaturn := hpplanet*60;


    NLINE := NLINE + 1;

    IF (NLINE <>0) AND ((NLINE MOD 5) = 0) THEN
    BEGIN
      IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
     WRITELN
 (lst,'                                                                           ');
    END;

    T := T + DT;   zaehl := zaehl + 1;
  END;

   IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
  WRITELN
  (lst,'                                                                           ');
   IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
  WRITELN
(lst,'Unt    ',(60*untv/22):4:1,'       ',(60*summev/22):3:1,
   '    ',(60*untm/22):4:1,'       ',(60*summem/22):3:1,
   '    ',(60*untj/22):4:1,'       ',(60*summej/22):3:1,
   '    ',(60*unts/22):4:1,'       ',(60*summes/22):3:1,'');
   IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
  WRITELN
  (lst,'               HP=',hpvenus:3:1,'            HP=',hpmars:3:1,
  '            HP=',hpjupiter:3:1,
  '            HP=',hpsaturn:3:1,'');


  IF AUSGABEMEDIUM ='HP'THEN
  BEGIN
    { Seitenvorschub }
    WRITE (lst, chr (12));
  END;

  IF AUSGABEMEDIUM = 'EPSON' THEN
  BEGIN
    WRITELN (lst, chr(27),'l',chr(1), chr (27),'2',chr(27),chr(18));
    WRITE (lst, chr (12));
   IF ende = false THEN
                     BEGIN
                     GOTOXY (17,23); HIGHVIDEO; TEXTCOLOR (14);
                     WRITE ('Bitte neues Blatt einlegen...    Weiter -> ');
                     REPEAT until KEYPRESSED; CH2 := READKEY;
                     GOTOXY (17,23);
                     WRITE ('                                              ');
                     LOWVIDEO; TEXTCOLOR (7);
                     END;
   END;
END;



PROCEDURE TRANSI (VAR grt12:extended);
VAR t, zeit   : extended;
BEGIN
  t:=grt12-180;
  IF t>0 THEN BEGIN
                t := 360 - grt12;
                zeit := 24 * t / 360;    {als Dezimalzahl}
                Transitus := 12 + zeit;
              END
         ELSE BEGIN
                t := grt12;
                zeit := 24 * t / 360;
                Transitus := 12 - zeit;
              END;
END;




PROCEDURE njseite;
VAR h, m : INTEGER;
       s : extended;
    mstring : STRING;

BEGIN

  IF AUSGABEMEDIUM = 'HP' THEN                        { HP-DRUCKER}
  BEGIN
    WRITELN (lst);   WRITELN (lst);   WRITELN (lst);   WRITELN (lst);
    {DIN A 4, Zeichensatz PC 8 Wahl, Courierschrift}
    WRITE (lst,chr(27),'&l26A');
    WRITE (lst, chr(27),'(10U');
    WRITE (lst, chr(27),'(s3T');
    { linker Rand,  Zeilenvorschub 1/8 }
    WRITE (lst,chr(27),'&l8D');            { Zeilen pro Zoll }
    { Fettdruck }
    WRITE (lst, chr(27),'(s3B');                    { Fett }
    WRITE (lst,chr(27),'&k0S');
    WRITELN (lst);
    WRITELN (lst);
    WRITE (lst,chr(27),'(s24S');       { gedehnt }
  END;

  IF AUSGABEMEDIUM = 'EPSON' THEN                          {EPSON DRUCKER}
  BEGIN
    { Schmaldruck aus }   WRITE (LST, chr(18));

    { linker Rand,  Zeilenvorschub 1/8, Schmaldruck aus }
    WRITE (lst,chr(27),'l',CHR (20),chr(27),'0');

    { Breitschrift, Fettdruck }
    WRITE (lst, CHR (27),'W1');  WRITELN (lst, CHR(27),'E');
  END;


  T := T_START;
  MODJD := T*36525.0 + 51544.5;  CALDAT (MODJD+0.5,DAY,MONTH,YEAR,hour);


  IF AUSGABEMEDIUM = 'HP' THEN                           {HP DRUCKER}
  BEGIN
    WRITELN
    (lst,'                         DATUM :   ',day,'.',month,'.',year);
    WRITE (lst,chr(27),'(s0S');
    WRITELN (lst);
    WRITELN (lst);
    WRITELN (lst);

    { Schmalschrift  Fettdruck aus }
    WRITE (lst,chr (27),'(s0B');                      { Fett weg }
    WRITE (lst,chr(27),'&k2S');          { Zeichen pro Zoll 16.67 }

    WRITELN
    (lst,'                              ',
    chr(27),'&d1D',' SONNE ',chr(27),'&d@','            ',
    chr(27),'&d1D',' MOND ',chr(27),'&d@','                                ',
    chr(27),'&d1D',' ARIES ', chr(27),'&d@');
  END;

  IF AUSGABEMEDIUM = 'EPSON' THEN                           {EPSON DRUCKER}
  BEGIN
    WRITELN (lst);  WRITELN (LST);  WRITELN (lst);
    WRITELN
    (lst,'DATUM :   ',day,'.',month,'.',year);
    { Schmalschrift  Fettdruck aus     alles fuer Epson lx800 }
    WRITELN (lst, CHR(27),'F',chr(27),'W0');
    WRITELN (lst,chr(15));
    WRITELN
    (lst,'     ',chr(27),'-1',' SONNE ',chr(27),'-0','            ',
    chr(27),'-1',' MOND ',chr(27),'-0','                                ',
    chr(27),'-1',' ARIES ', chr(27),'-0');
  END;

  IF AUSGABEMEDIUM='HP' THEN                               {HP DRUCKER}
  WRITE (lst,'                         ');
  WRITELN
  (lst,'UT1   Grt               Grt      Unt            Unt   HP     Grt');
  IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
  WRITELN
  (lst,' h                                             ');
  T := T_START;   TB := T_START;   NLINE := 0;    zaehl := -1;
  WHILE (T<=T_END) DO
  BEGIN
      IF (T>TB-T_OVERLAP) THEN
        BEGIN
          TA := T-T_OVERLAP;  TB := T+T_DEVELOP+T_OVERLAP;
          T_FIT_MOON (TA,TB,MAX_TP_DEG,RA_POLY,DE_POLY,R_POLY);
        END;

      (* date *)
      MODJD := T*36525.0 + 51544.5;  CALDAT (MODJD,DAY,MONTH,YEAR,hour);

      grtalt:=grt; dealt := DE;  paralt := par; ariesalt:=ariesgrad;
      grtplanalt:=grtplan; decplanalt:= decplan;

      (* coordinates *)
      RA  := T_EVAL(RA_POLY,T)/15.0;  IF RA<0.0 THEN RA := RA + 24.0;
      ARIESPFLEGER (day, month, year,ROUND(hour),0,0);
      GRT := RAnachGRT (RA);
      DE  := T_EVAL(DE_POLY,T);
      R   := T_EVAL(R_POLY, T);
      PAR := ASN(1.0/R);

      planeti (day, month, year, hour, 0, 0, 'Sonne');

      (* print coordinates *)
      IF (zaehl >=1)AND (zaehl<25) THEN
                       BEGIN
                         IF hour = 0 THEN hour := 24;
                         IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
                         WRITE (lst,(ABS(hour-1)):2:0);
                         unt := ABS((DE-dealt)*60);
                         gg := GRT;
                         IF grt < grtalt THEN gg := grt+360;
                         untgrt:=((gg-grtalt)-14.3166666666)*60;

                         IF ROUND(ABS(hour-1)) = 12 THEN TRANSI (grtplanalt);

                         DRucKnj (grtplanalt, decplanalt,grtalt,untgrt,DEalt,unt,PARalt,ariesalt);
                         NLINE := NLINE +1;
                         IF zaehl = 10 then BEGIN
                         gg := decplan;
                         untsonne := ABS(decplan-decplanalt)*60;
                                            END;
                       END;

      IF (NLINE <>0) AND ((NLINE MOD 5) = 0) THEN
      BEGIN
          IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
         WRITELN
 (lst,'                                                                    ');
      END;
      T :=  T+DT;    zaehl := zaehl +1;
  END;
   IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
   WRITELN
 (lst,'                                                                    ');


  DMS (Transitus,h,m,s);
  m:=m + Round (s/60);
  IF m>=60 THEN BEGIN
                  h:=h+1;
                  m:=0;
                END;
  STR (m, mstring);
  IF m<10 THEN mstring := '0' + mstring;
   IF AUSGABEMEDIUM='HP'THEN WRITE (lst,'                         ');
  writeln
  (lst,'     T=',h,'.',mstring,'  Unt=',untsonne:2:1,'                                               ');
  WRITELN (lst);
  plandruck;
END;





PROCEDURE druck (plang, pland, L,untgrt,B,unt,P, A:extended);
  VAR H,M: INTEGER;
      S  : extended;
  BEGIN
    DMS (plang,h,m,s);
    WRITE (datei,'  ',H:3,(M+S/60):5:1,'');
    DMS (pland,h,m,s);
    IF pland < 0 THEN BEGIN
                        WRITE (datei,'S');
                        pland := ABS (pland);
                      END
                      ELSE WRITE (datei,'N');
    DMS (pland,H,M,S);
    WRITE (datei,H:3,(M+S/60):5:1);

    DMS(L,H,M,S);
    WRITE (datei,'',H:4,(M+S/60):5:1,' ',untgrt:5:1,'');

    IF b < 0 THEN BEGIN
                    WRITE (datei,'S');
                    B := ABS (b);
                  END
                  ELSE  WRITE (datei,'N');
    DMS (B,H,M,S);
    WRITE (datei,H:3 ,(M+S/60):5:1,' ',unt:5:1);

    DMS(P,H,M,S);
    IF (H>0) THEN M:=M+60;  WRITE (datei,'',(M+S/60):5:1);

    DMS (A,H,M,S);
    WRITELN (datei,' ',H:4,(M+S/60):5:1);
  END;





PROCEDURE planeten;

VAR  H, M  : INTEGER;
     S, T1, T2, DT, hpvenus, hpmars, hpjupiter, hpsaturn           : extended;
     decplanv, decplanvalt, summev, summem, summej, summes, dif    : extended;
     decplanm, decplanj, decplans, decplanmalt, decplanjalt,
     decplansalt, unt, untv,grtplanv, grtplanvalt, grtplanm,
     grtplanmalt, grtplanj, grtplanjalt, grtplans, grtplansalt,
     untj, unts, untm : extended;

BEGIN
  hour := 0;  summev :=0;  summem :=0; summej :=0;  summes :=0;
  untv := 0;  untm := 0;  untj := 0;  unts := 0; unt :=0;

  T := T_START;
  MODJD := T*36525.0 + 51544.5;  CALDAT (MODJD+(0.5/12),DAY,MONTH,YEAR,hour);

  WRITELN (datei);

  T1 :=  ( MJD(day,month,year,hour) - 51544.5 ) / 36525.0;
  T2 :=  ( MJD(day,month,year,hour+23.1) - 51544.5 ) / 36525.0;
  DT := (1/24)/36525;
  T := T1;
  WRITELN (datei);
  WRITELN
  (datei,'         VENUS              MARS            JUPITER            SATURN      ');
  WRITELN
  (datei,'UT1  Grt              Grt              Grt              Grt            ');
  WRITELN
  (datei,' h                                                 ');

  NLINE := 0;
  WHILE T < T2 DO
  BEGIN
    MODJD := T * 36525.0 + 51544.5; CALDAT (MODJD, DAY, MONTH, YEAR, hour);
    ARIESPFLEGER (day, month, year, ROUND(hour), 0,0);


    WRITE (datei,ABS(hour):2:0,' ');

    grtplanvalt := grtplanv;
    decplanvalt := decplanv;
    planeti (day, month, year, hour, 0,0, 'Venus');
    DMS (grtplan,H,M,S);
    WRITE (datei,H:3,(m+s/60):5:1,'');
    decplanv := decplan;
    grtplanv := grtplan;
    IF decplanv < 0 THEN WRITE (datei,'S')  ELSE WRITE (datei,'N');
    decplanv := ABS (decplanv);
    DMS (decplanv,H,M,S);
    IF (hour > 0) AND (hour < 23) THEN
    BEGIN
      dif := ABS (decplanv-decplanvalt);
      summev :=summev + dif;
      IF grtplanv < grtplanvalt THEN grtplanv := grtplanv +360;
      unt := grtplanv - grtplanvalt - 15;
      untv := untv + unt;
    END;
    WRITE (datei,H:3,(m+s/60):5:1,'');
    IF INT(hour) = 12 THEN hpvenus:=hpplanet*60;

    grtplanmalt := grtplanm;
    decplanmalt := decplanm;
    planeti (day, month, year, hour, 0,0, 'Mars');
    DMS (grtplan,H,M,S);
    WRITE (datei,H:3,(m+s/60):5:1,'');
    decplanm := decplan;
    grtplanm := grtplan;
    IF decplan < 0 THEN WRITE (datei,'S')  ELSE WRITE (datei,'N');
    decplan :=  ABS (decplan);
    DMS (decplan,H,M,S);
    IF (hour > 0) AND (hour < 23) THEN
    BEGIN
      dif := ABS (decplanm-decplanmalt);
      summem :=summem + dif;
      IF grtplanm < grtplanmalt THEN grtplanm := grtplanm + 360;
      unt := grtplanm - grtplanmalt - 15;
      untm := untm + unt;
    END;
    WRITE (datei,H:3,(m+s/60):5:1,'');
    IF INT(hour) = 12 THEN hpmars := hpplanet*60;

    grtplanjalt := grtplanj;
    decplanjalt := decplanj;
    planeti (day, month, year, hour, 0,0, 'Jupiter');
    DMS (grtplan,H,M,S);
    WRITE (datei,H:3,(m+s/60):5:1,'');
    decplanj := decplan;
    grtplanj := grtplan;
    IF decplan<0 THEN WRITE (datei,'S')  ELSE WRITE (datei,'N');
    decplan := ABS (decplan);
    DMS (decplan,H,M,S);
    IF (hour > 0) AND (hour < 23) THEN
    BEGIN
      dif := ABS (decplanj-decplanjalt);
      summej :=summej + dif;
      IF grtplanj < grtplanjalt THEN grtplanj := grtplanj + 360;
      unt := grtplanj- grtplanjalt - 15;
      untj := untj + unt;
    END;
    WRITE (datei,H:3,(m+s/60):5:1,'');
    IF INT(hour) = 12 THEN hpjupiter := hpplanet*60;

    grtplansalt := grtplans;
    decplansalt := decplans;
    planeti (day, month, year, hour, 0,0, 'Saturn');
    DMS (grtplan,H,M,S);
    WRITE (datei,H:3,(m+s/60):5:1,'');
    decplans := decplan;
    grtplans := grtplan;
    IF decplan<0 THEN WRITE (datei,'S')  ELSE WRITE (datei,'N');
    decplan := ABS (decplan);
    DMS (decplan,H,M,S);
    IF (hour > 0) AND (hour < 23) THEN
    BEGIN
      dif := ABS (decplans-decplansalt);
      summes :=summes + dif;
      IF grtplans < grtplansalt THEN grtplans := grtplans + 360;
      unt := grtplans - grtplansalt -15;
      unts := unts + unt;
    END;
    WRITELN (datei,H:3,(m+s/60):5:1,'');

    IF INT(hour) = 12 THEN hpsaturn := hpplanet*60;


    NLINE := NLINE + 1;

    IF (NLINE <>0) AND ((NLINE MOD 5) = 0) THEN BEGIN WRITELN
 (datei,'                                                                           ');
 WRITE (' . ');
                                                END;

    T := T + DT;   zaehl := zaehl + 1;
  END;
  WRITELN
  (datei,'                                                                           ');
  WRITELN
(datei,'Unt    ',(60*untv/22):4:1,'       ',(60*summev/22):3:1,
   '    ',(60*untm/22):4:1,'       ',(60*summem/22):3:1,
   '    ',(60*untj/22):4:1,'       ',(60*summej/22):3:1,
   '    ',(60*unts/22):4:1,'       ',(60*summes/22):3:1,'');
  WRITELN
  (datei,'               HP=',hpvenus:3:1,'            HP=',hpmars:3:1,
  '            HP=',hpjupiter:3:1,
  '            HP=',hpsaturn:3:1,'');
  {ende einer Seite}

END;






PROCEDURE bildschirm;
VAR h, m : INTEGER;
       s : extended;
  mstring : STRING;

BEGIN

  T := T_START;
  MODJD := T*36525.0 + 51544.5;  CALDAT (MODJD+0.5,DAY,MONTH,YEAR,hour);

  WRITELN (datei);  WRITELN (datei);  WRITELN (datei);  WRITELN (datei);
  WRITELN
  (datei,'DATUM :   ',day,'.',month,'.',year,'       ');
  WRITELN (datei);
  WRITELN
  (datei,'      SONNE              MOND                                  ARIES');
  WRITELN
  (datei,'UT1   Grt               Grt      Unt            Unt   HP     Grt');
  WRITELN
  (datei,' h                                             ');
  T := T_START;   TB := T_START;

    NLINE := 0;    zaehl := -1;
  WHILE (T <= T_END) DO
  BEGIN
      IF (T>TB-T_OVERLAP) THEN
        BEGIN
          TA := T-T_OVERLAP;  TB := T+T_DEVELOP+T_OVERLAP;
          T_FIT_MOON (TA,TB,MAX_TP_DEG,RA_POLY,DE_POLY,R_POLY);
        END;

      (* date *)
      MODJD := T*36525.0 + 51544.5;  CALDAT (MODJD,DAY,MONTH,YEAR,hour);


      grtalt:=grt; dealt := DE;  paralt := par; ariesalt:=ariesgrad;
      grtplanalt:=grtplan; decplanalt:= decplan;



      (* coordinates *)
      RA  := T_EVAL(RA_POLY,T)/15.0;  IF RA<0.0 THEN RA := RA + 24.0;
      ARIESPFLEGER (day, month, year,ROUND (hour),0,0);
      GRT := RAnachGRT (RA);
      DE  := T_EVAL(DE_POLY,T);
      R   := T_EVAL(R_POLY, T);
      PAR := ASN(1.0/R);

      MODJD := T*36525.0 + 51544.5;  CALDAT (MODJD,DAY,MONTH,YEAR,hour);
      planeti (day, month, year, hour, 0, 0, 'Sonne');


      (* print coordinates *)
      IF (zaehl >=1)AND (zaehl<25) THEN
                       BEGIN
                         IF hour = 0 THEN hour := 24;
                         WRITE (datei,(ABS(hour-1)):2:0);
                         unt := ABS((DE-dealt)*60);
                         gg := GRT;
                         IF grt < grtalt THEN gg := grt+360;
                         untgrt:=((gg-grtalt)-14.3166666666)*60;


                         IF ROUND(ABS(hour-1)) = 12 THEN TRANSI (grtplanalt);


                         DRUCK (grtplanalt, decplanalt,grtalt,untgrt,DEalt,unt,PARalt,ariesalt);
                         NLINE := NLINE +1;
                         IF zaehl = 10 then BEGIN
                         gg := decplan;
                         untsonne := ABS(decplan-decplanalt)*60;
                                            END;
                       END;

      IF (NLINE <>0) AND ((NLINE MOD 5) = 0) THEN BEGIN
      WRITELN
 (datei,'                                                                     ');
      WRITE (' . ');
                                                   END;
      T :=  T+DT;    zaehl := zaehl +1;
  END;

  DMS (Transitus, h, m, s);
  m := m + ROUND ( s/60);
  IF m>=60 THEN BEGIN
                  h:=h+1;
                  m:=0;
                END;
  STR (m, mstring);
  IF m<10 THEN mstring := '0'+mstring;

  WRITELN
 (datei,'                                                                     ');
    
  writeln
  (datei,'     T=',h,'.',mstring,'  Unt=',untsonne:2:1,'                                               ');

  planeten;
END;





PROCEDURE njanzahl (tag, monat, jahr, tageszahl : INTEGER;
                     ausgabemedium : STRING);
VAR zahler : INTEGER;
BEGIN
    ende := false;
    FOR zahler :=0 to tageszahl-1 DO
    BEGIN

                          GOTOXY(5,24);
                          TEXTCOLOR (lightgreen);
                          IF (AUSGABEMEDIUM ='DATEI')
                          THEN
                            WRITE
                            ('  NJ.TXT  -  Seite:                                    ')
                          ELSE
                            WRITE
                            ('  Drucken von Seite:                                    ');
                          GOTOXY(27,24);
                          WRITE (zahler+1,'  ');

    IF zahler = 0 THEN BEGIN
                         IF (AUSGABEMEDIUM='HP')OR(AUSGABEMEDIUM='EPSON')
                         THEN njseite
                         ELSE bildschirm
                       END
                  ELSE
                      BEGIN
                         IF zahler = tageszahl-1 THEN ende := TRUE;
                         T_START := T_START + (1/36525.0);
                         T_END :=  T_END + (1/36525.0);
                         IF (AUSGABEMEDIUM='EPSON')OR(AUSGABEMEDIUM='HP')
                         THEN njseite
                         ELSE bildschirm;
                       END;
    END;

  END;





PROCEDURE STERNPRINT (tag, monat, jahr : INTEGER;
                      AUSGABEMEDIUM : STRING);
VAR I : INTEGER;
BEGIN
    TEXTCOLOR (lightred);
    WRITELN;
    WRITE ('                   Drucker bereitmachen... ');
    repeat until keypressed; ch2 := readkey;

  writeln (lst);  writeln (lst);
  WRITELN (lst);  WRITELN (lst);
  IF AUSGABEMEDIUM = 'EPSON' THEN WRITE (lst,chr(27),'E');
  IF AUSGABEMEDIUM = 'HP' THEN WRITE (lst,chr(27),'E');
  WRITELN (lst,'       Datum : ',tag,'.',monat,'.',jahr:4);
  WRITELN (lst);
  WRITELN (lst);
  WRITELN(lst,'         Nummer   Navigationsstern           Sternwinkel        ');
  WRITELN (LST);
  write(  lst,'                                                              ');

  WRITELN (lst);
  IF AUSGABEMEDIUM = 'EPSON' THEN WRITE (lst,chr(27),'F');
  IF AUSGABEMEDIUM = 'HP' THEN WRITE (lst,chr(27),'F');
  FOR I:=1 to 40 DO
  BEGIN
    if ((i-1)/5) = INT ((i-1)/5) THEN writeln (lst);
    write(lst,'          ',i:2);
    write(lst,'      ',name[i]:20);
    write(lst,'       ',INT(winkel[i]):3:0,'  ',(FRAC(winkel[i])*60):4:1);
    write(lst,'      ',ABS(INT(decli[i])):4:0,' ',ABS(FRAC(decli[i])*60):5:1);
    IF decli[i] >0 THEN writeln (lst,' N')  ELSE writeln (lst,' S');

  END;
  writeln (lst);

  writeln;
  TEXTCOLOR (4); highvideo;      writeln;
  IF AUSGABEMEDIUM = 'EPSON' THEN
  BEGIN
    write ('    Erste Seite entnehmen, neues Blatt einlegen...    und Taste drcken!');
    WRITELN (lst, chr(12));
    repeat until keypressed;  ch := readkey;
  END;
  IF AUSGABEMEDIUM = 'HP' THEN BEGIN END;

  LOWVIDEO;
  writeln (lst);  writeln (lst);
  IF AUSGABEMEDIUM = 'EPSON' THEN WRITE (lst,chr(27),'E');
  IF AUSGABEMEDIUM = 'HP' THEN WRITE (lst,chr(27),'E');
  WRITELN (lst,'       Datum : ',tag,'.',monat,'.',jahr:4);
  WRITELN (lst);
  WRITELN (lst);
  WRITELN(lst,'         Nummer   Navigationsstern           Sternwinkel        ');
  WRITELN (lst);
  write  (lst,'                                                              ');
  WRITELN (lst);
  IF AUSGABEMEDIUM = 'EPSON' THEN WRITE (lst,chr(27),'F');
  IF AUSGABEMEDIUM = 'HP' THEN WRITE (lst,chr(27),'F');
  FOR I:=41 to 80 DO
  BEGIN
    if ((i-1)/5) = INT ((i-1)/5) THEN writeln (lst);
    write(lst,'          ',i:2);
    write(lst,'      ',name[i]:20);
    write(lst,'       ',INT(winkel[i]):3:0,'  ',(FRAC(winkel[i])*60):4:1);
    write(lst,'      ',ABS(INT(decli[i])):4:0,' ',ABS(FRAC(decli[i])*60):5:1);
    IF decli[i] >0 THEN writeln (lst,' N')  ELSE writeln (lst,' S');

  END;
  writeln (lst);
  IF AUSGABEMEDIUM = 'EPSON' THEN WRITELN (lst, chr(12));
  IF AUSGABEMEDIUM = 'HP' THEN WRITELN (lst, chr(12));
END;




procedure sternespeichern;
VAR grad : REAL;
    min  : REAL;
    I    : INTEGER;

BEGIN
  WRITELN (datei, 'Datum : ',tag,'.',monat,'.',jahr:4);
  WRITELN (datei);
  WRITELN(datei,'Nummmer   Navigationsstern          Sternwinkel         ');
  write(datei,'                                                      ');
  FOR I:=1 to 80 DO
  BEGIN
    if ((i-1)/5) = INT ((i-1)/5) THEN writeln (datei);
    write(datei,'  ',i:2);
    write(datei,'      ',name[i]);
    write(datei,'       ',INT(winkel[i]):3:0,'  ',
         (FRAC(winkel[i])*60):4:1);
    write(datei,'      ',ABS(INT(decli[i])):4:0,' ',
          ABS(FRAC(decli[i])*60):5:1);
    IF decli[i] >0 THEN writeln (datei,' N')  ELSE writeln (datei,' S');
  END;

END;




PROCEDURE Sternpositionsberichtigung (sternwinkelalt, decgradalt:EXTENDED;
                                      tag, monat, jahr,
                                      stunde, minute, sekunde:INTEGER;
                                      VAR sternwinkelneu, decgradneu:EXTENDED);
VAR JD, Zeit, GW, G, LM, L, EP,
    HI1, HI2, HI3, HI4, HI5, TA,
    BETA, BETA1, BETA2, M, N,
    DEL, DEL1, DEL2, TJUL            : EXTENDED;

BEGIN
  {Berechnung verschiedener astronomischer Grundgren: }
  write ('');
  Zeit := Stunde + Minute/60 + Sekunde/3600;
  JD := MJD(tag, monat, jahr, Zeit);               {MJD = Julianisches Datum,
                                                    aus Montenbruck/Pfleger}
  TA := JD-51544.5;

  G := 357.528+0.9856003*TA;                      {mittlere Sonnenanomalie}
  LM := 280.46+0.9856474*TA;                      {mittlere Sonnenlnge}
  L := LM+1.915*SN(G)+0.2*SN(2*G);                  {Sonnenlnge}
  L := L-360*INT(L/360);
  EP := 23.439-0.0000004*TA;                      {Schiefe der Ekliptik}

  TJUL := TA/36525;
  M := 1.2812323*TJUL+0.0003879*TJUL*TJUL;
  N := 0.5567530000000001*TJUL-0.0001185*TJUL*TJUL;

  BETA := sternwinkelalt;
  DEL  := decgradalt;

  {Korrektur Przession:   }
  BETA1 := BETA-M+N*SN(BETA)*TN(DEL);
  DEL1  := DEL+N*CS(BETA);

  {Korrektur Aberation:    }
  HI1 := CS(BETA1)*CS(EP)*CS(L);
  HI2 := SN(BETA1)*SN(L);
  HI3 := CS(DEL1)*SN(EP)*CS(L);
  HI4 := CS(BETA1)*SN(DEL1)*SIN(L);
  HI5 := SN(BETA1)*SN(DEL1)*CS(EP)*CS(L);
  BETA2 := BETA1+0.005694*(HI1-HI2)/CS(DEL1);
  DEL2 := DEL1-0.005694*(HI3+HI4+HI5);

  sternwinkelneu := BETA2;
  decgradneu := DEL2;
END;




PROCEDURE Aktualisieren;
VAR I : INTEGER;

BEGIN
  FOR i :=1 TO 80 DO Sternpositionsberichtigung (winkel[i], decli[i],
                                                  tag, monat, jahr,
                                                  0,0,0,
                                                  winkel[i], decli[i]);
END;


PROCEDURE Sternelesen;
VAR ii, code : INTEGER;
    w,d      : STRING [20];

BEGIN
  name[ 1] := 'Sirrah              35754.2             2905.4';
  name[ 2] := 'Algenib im Pegasus  35644.5             1510.2';      {?}
  name[ 3] := ' Phoenicis         35325.8             -4218.4';
  name[ 4] := 'Schedir             34956.4             5630.7';      {?}
  name[ 5] := 'Deneb Kaitos        34906.2             -1759.2';
  name[ 6] := 'Gamma Cassiopeiae   34553.9             6041.9';      {?}
  name[ 7] := 'Mirach              34234.0             3537.2';
  name[ 8] := 'Archernar           33534.3             -5714.2';
  name[ 9] := 'Nordstern           32403.6             8915.2';      {?}
  name[10] := 'Alamak              32905.4             4218.9';      {?}
  name[11] := 'Hamel               32812.4             2327.7';
  name[12] := 'Menkar              31425.8             405.4';
  name[13] := 'Algol               31257.5             4057.3';
  name[14] := 'Algenib im Perseus  30855.2             4951.7';
  name[15] := 'Alcyone             30307.8             2406.3';
  name[16] := 'Aldebaran           29101.2             1630.5';
  name[17] := 'Rigel               28122.0             -812.1';
  name[18] := 'Capella             28049.7             4559.9';
  name[19] := 'Bellatrix           27843.0             621.0';
  name[20] := ' Tauri             27829.4             2837.0';      {?}
  name[21] := ' Orionis           27559.7             -113.4';      {?}
  name[22] := 'Chi Orionis         27451.5             -155.7';      {?}
  name[23] := 'Xi Orionis          27306.5             -939.6';      {?}
  name[24] := 'Beteigeuze          27112.4             724.4';
  name[25] := ' Aurigae           27007.1             4456.8';
  name[26] := ' Canis majoris     26421.9             -1756.8';     {?}
  name[27] := 'Canopus             26400.7             -5241.7';
  name[28] := 'Gamma Geminorum     26034.3             1624.0';
  name[29] := 'Sirius              25842.8             -1643.0';
  name[30] := ' Canis majoris     25520.2             -2858.3';
  name[31] := ' Canis majoris     25256.6             -2622.8';     {?}
  name[32] := 'Castor              24621.0             3153.3';
  name[33] := 'Procyon             24510.5             513.5';
  name[34] := 'Pollux              24340.3             2801.6';
  name[35] := ' Carinae           23422.3             -5930.6';
  name[36] := 'Lambda Velorum      22302.4             -4324.4';     {?}
  name[37] := ' Carinae           22142.0             -6943.0';
  name[38] := 'Alphard             21806.2             -839.5';
  name[39] := 'Regulus             20754.5             1158.0';
  name[40] := ' Carinae           19919.1             -6421.8';     {?}
  name[41] := 'Dubhe               19404.1             6145.0';
  name[42] := 'Denebola            18244.1             1434.3';
  name[43] := ' Crucis            17321.0             -6305.9';
  name[44] := 'Gamma Crucis        17212.5             -5706.8';
  name[45] := ' Crucis            16804.2             -5941.3';
  name[46] := 'Alioth              16639.9             5602.7';      {?}
  name[47] := 'Vindemiatrix        16439.1             1102.6';      {?}
  name[48] := 'Mizar               15910.6             5500.4';      {?}
  name[49] := 'Spica               15842.1             -1109.7';
  name[50] := 'Benetnasch          15306.9             4918.8';
  name[51] := ' Centauri          14902.7             -6022.4';
  name[52] := ' Centauri          14833.8             -3617.6';     {?}
  name[53] := 'Arcturus            14605.1             1911.0';
  name[54] := ' Centauri          14005.8             -6050.0';
  name[55] := 'Mirak               13855.5             2708.4';      {?}
  name[56] := 'Zubenelgenubi       13716.9             -1602.5';
  name[57] := 'Kochab              13719.5             7409.3';
  name[58] := 'Zubeneschemali      13057.7             -919.6';      {?}
  name[59] := 'Gemma               12629.7             2646.0';      {?}
  name[60] := 'Unuk                12356.0             625.5';
  name[61] := 'Antares             11238.9             -2625.9';
  name[62] := ' Trianguli A.      10750.1             -6901.6';
  name[63] := ' Scorpii           10743.0             -3416.0';     {?}
  name[64] := 'Lambda Scorpii       9635.9             -3706.2';
  name[65] := 'Ras Alhague          9616.0             1233.6';
  name[66] := ' Scorpii            9540.3             -4259.6';
  name[67] := 'Eltanin              9051.0             5129.3';
  name[68] := ' Sagittarii         8357.4             -3423.1';
  name[69] := 'Wega                 8045.9             3847.0';
  name[70] := ' Sagittarii         7625.7             -2619.1';     {?}
  name[71] := 'Altair               6218.3             852.1';
  name[72] := ' Pavonis            5335.3             -5644.1';
  name[73] := 'Deneb                4938.6             4516.8';
  name[74] := 'Alderamin            4027.1             6231.1';      {?}
  name[75] := 'Enif                 3357.2             952.5';
  name[76] := ' Gruis              2756.6             -4657.7';
  name[77] := ' Gruis              1920.0             -4653.1';
  name[78] := 'Fomalhaut            1535.3             -2937.3';
  name[79] := 'Scheat               1414.9             2759.8';
  name[80] := 'Markab               1400.4             1507.2';

  II:=0;
  WHILE ii<80 DO BEGIN
     II:=II+1;
                        w := COPY (name[ii],21,7);
                        VAL(w, winkel[ii],code);
                        IF code <> 0 THEN BEGIN
                                            w:=COPY(w,1,code-1);
                                            VAL(w,winkel[ii],code);
                                          END;
                        d := COPY (name[ii],41,7);
                        VAL(d, decli[ii],code);
                        IF code <> 0 THEN BEGIN
                                            d:=COPY(d,1,code-1);
                                            VAL(d,decli[ii],code);
                                          END;
                        name[ii] := COPY(name[ii],1,20);
                        winkel[ii]:=INT(winkel[ii]/100)+FRAC(winkel[ii]/100)*100/60;
                        decli[ii]:= INT(decli[ii]/100)+FRAC(decli[ii]/100)*100/60;

                   END;
                      aktualisieren;
END;






PROCEDURE datumini;
VAR code                            : INTEGER;
    datum                           : STRING;
    j,t,m,wtag                      : WORD;
BEGIN
  esc := FALSE;
  WRITE ('  DATUM:                   Tag Monat Jahr : ');   eingabe (datum);
  VAL (COPY(datum,1,2),tag,code);
  IF code <> 0 THEN BEGIN
                      datum := '0'+datum;
                      VAL (COPY(datum,1,2),tag,code);
                    END;
  VAL (COPY(datum,4,2),monat,code);
  IF code <> 0 THEN BEGIN
                      datum := COPY(datum,1,3)+'0'+COPY(datum,4,6);
                      VAL (COPY(datum,4,2),monat,code);
                    END;
  VAL (COPY(datum,7,4),jahr,code);
  IF (jahr < 100) THEN jahr := 2000+jahr;

  IF esc = TRUE THEN EXIT;

  {Systemdatumbernahme}
  IF (tag=0) and (monat=0) THEN BEGIN
                                  GETDATE (j,m,t,wtag);
                                  tag :=t;
                                  monat :=m;
                                  jahr := j;
                                END;

  GOTOXY (45,20);  TEXTBACKGROUND (7); TEXTCOLOR (0);
  WRITELN ('                 ');
  GOTOXY (45,20);
  WRITELN ('    ',tag,'.',monat,'.',jahr);
  TEXTCOLOR (7); TEXTBACKGROUND (0);

END;





PROCEDURE TITTEL;
VAR code : INTEGER;

  BEGIN
   CLRSCR;
   TEXTBACKGROUND(4); TEXTCOLOR (6);                        highvideo;
   WRITELN ('******************************************************************************');
   WRITELN ('* Nautisches Jahrbuch, Tagesseitendruck                 DF2IAX, Version 2000 *');
   WRITELN ('******************************************************************************');
   WRITELN;          TEXTBACKGROUND(0);     TEXTCOLOR (15);

   WRITELN (' Zur Berechnung der:      - einzelnen Tagesseiten (ohne Sternrter)');
   WRITELN ('                          - Sternrter');
   WRITELN;                lowvideo;
   WRITELN ('  Dabei gengt es vllig, sich die Sternrter nur einmal auszudrucken,');
   WRITELN ('  (z.B fr die Urlausmitte) und nicht fr jeden Tag!');
   WRITELN;
   HIGHVIDEO;
   WRITELN ('  Ausgabemedium:  1. HP-(PCL)-Drucker (Laserjet, Deskjet)');
   WRITELN ('                  2. EPSON-(Nadel)-Drucker  (FX, LX, LQ)');
   WRITELN ('                  3. ASCII-Textdatei (NJ.TXT bzw. STERNE.TXT) ');

   TEXTCOLOR (2);       HIGHVIDEO;
   WRITE   ('                                                                  Wahl : ');
   esc := false;
   eingabe (wahl);
   IF wahl = '1' THEN AUSGABEMEDIUM := 'HP';
   IF wahl = '2' THEN AUSGABEMEDIUM := 'EPSON';
   IF wahl = '3' THEN AUSGABEMEDIUM := 'DATEI';
   IF ESC = TRUE THEN EXIT;

   TEXTCOLOR (15);
   WRITELN;
   WRITELN ('  Was wnschen Sie ? :    1. Die Tagesseiten des NJ');
   WRITELN ('                          2. Die Sternrter');
   TEXTCOLOR (2);       HIGHVIDEO;
   WRITE   ('                                                                  Wahl : ');
   esc := false;
   eingabe (wahl);
   IF wahl = '1' THEN aktion := 'TAGESSEITEN';
   IF wahl = '2' THEN aktion := 'STERNRTER';
   IF esc = True THEN EXIT;

   TEXTCOLOR (15);
   WRITELN;
   datumini;

   IF aktion = 'TAGESSEITEN' THEN
   BEGIN
     HIGHVIDEO;
     WRITE ('  Wieviele Tage sollen berechnet werden ? : ');
     esc := FALSE;
     eingabe (wahl);
     VAL(wahl, tageszahl,code);
     IF esc = true THEN EXIT;
     hour := 0;
     T_START :=  ( MJD(tag,monat,jahr,hour-1) - 51544.5 ) / 36525.0;
     T_END :=  ( MJD(tag,monat,jahr,hour+25) - 51544.5 ) / 36525.0;
     DT := (1/24)/36525;
   END;

END;



PROCEDURE DATEIENDA;

VAR F          : SEARCHREC;
    NJ, INFO   : BOOLEAN;

BEGIN
  NJ := FALSE; INFO := FALSE;
  FINDFIRST ('*.*',archive,F);
  IF F.Name = 'ASTRO.EXE' THEN NJ := TRUE;
  IF F.Name = 'INFO.TXT' THEN INFO := TRUE;
  WHILE (DOSERROR = 0) AND NOT((NJ=TRUE)AND(INFO=TRUE)) DO
     BEGIN
       FINDNEXT (F);
       IF F.Name = 'ASTRO.EXE' THEN NJ := TRUE;
       IF F.Name = 'INFO.TXT' THEN INFO := TRUE;
     END;

  IF (NJ=FALSE) OR (INFO=FALSE) THEN
  BEGIN
   TEXTCOLOR (LIGHTRED);
   WRITELN;
   WRITELN ('Dieses Programm ist unvollstndig kopiert worden!  Es fehlt:', chr(7));
   WRITELN;
   IF NJ = FALSE THEN
   WRITELN ('  ASTRO.EXE  das Hauptprogramm zur astronomischen Navigation');
   IF INFO = FALSE THEN
   WRITE ('  INFO.TXT   ein Textfile mit Hinweisen zur Programmanwendung   ');
   REPEAT UNTIL KEYPRESSED; CH := READKEY;
   TEXTCOLOR (7);
  END;
END;




procedure ENDEN;
BEGIN
   Textcolor (7);
   CLRSCR;
   IF IORESULT <>0 THEN BEGIN
                          TEXTCOLOR (lightred);
                          WRITELN (' Es trat ein I/O-Fehler auf.');
   WRITELN (' Eventuell ist Ihr Drucker nicht an, oder es gab einen Disketten-');
   WRITELN (' oder Plattenfehler.');
   WRITELN;   TEXTCOLOR (7);
   END;


   WRITELN
  (' Programmfehler, Verbesserungsvorschlge oder hnliches bitte mir melden:');
  writeln;
  writeln ('      Mike Stefanski                       Afu-Call: DF2IAX ');
  writeln ('      Beethovenstr 28');
  writeln ('      76275 Ettlingen');
  writeln;
  writeln (' Dieses Programm darf jeder frei kopien, weitergeben und zum privaten Segel-');
  writeln (' sport nutzen !   ');
  WRITELN;
  writeln ('      Ich verbiete aber, mit meinem Programm auf irgendeine Art und');
  writeln ('      Weise Profit zu erwirtschaften !!!');
  writeln;
  writeln;
  dateienda;
END;



BEGIN   (* main program *)

    AUSGABEMEDIUM := '';
    AKTION := '';

    tittel ;

    {Tagesseitendruck}
    IF ((AUSGABEMEDIUM='HP')OR(AUSGABEMEDIUM= 'EPSON'))AND(AKTION='TAGESSEITEN')
    THEN BEGIN
           TEXTCOLOR (LIGHTRED); writeln;
           WRITE ('                          Drucker bereit machen...       ');
           REPEAT UNTIL KEYPRESSED; CH := READKEY;
           njanzahl (tag, monat, jahr, tageszahl, ausgabemedium);
         END;

    {Tagesseiten als Textfile speichern}
    IF (AUSGABEMEDIUM='DATEI')AND(AKTION='TAGESSEITEN')
    THEN BEGIN
           ASSIGN (datei,'NJ.TXT');
           REWRITE (datei);
           njanzahl (tag, monat, jahr, tageszahl, ausgabemedium);
           CLOSE (datei);
           WRITE ('    FERTIG !!!');
           REPEAT UNTIL KEYPRESSED; CH := READKEY;
         END;


    {Sternrter drucken}
    IF ((AUSGABEMEDIUM='HP')OR(AUSGABEMEDIUM= 'EPSON'))AND(AKTION='STERNRTER')
    THEN BEGIN
          sternelesen;
          sternprint (tag, monat, jahr, AUSGABEMEDIUM);
         END;

    {Sternrter als textfile speichern}
    IF (AUSGABEMEDIUM='DATEI')AND(AKTION='STERNRTER')
    THEN BEGIN
           WRITELN;
           TEXTCOLOR (lightgreen);
           WRITE ( '           Textdatei STERNE.TXT wird geschrieben...    ');
           sternelesen;
           ASSIGN (datei,'STERNE.TXT');
           REWRITE (datei);
           sternespeichern;
           CLOSE (datei);
           WRITELN ('       FERTIG !!! ');
           REPEAT UNTIL KEYPRESSED; CH := READKEY;
         END;

    enden;
END.

